unit SampleProfiler;

interface

uses
  Windows, ComObj, BaseProfiler, CorProf;

type
  TSampleProfiler = class(TBaseProfiler, ICorProfilerCallback)
  protected
    procedure OnInitialize; override;
    procedure OnShutDown; override;
    procedure ClassLoadStarted(classId: ULONG); safecall;
  end;

const
  //Update these constants for each new profiler
  ProfilerCoClassName = 'SampleProfiler';
  ProfilerDescription = 'Sample profiler';
  ProfilerGUID: TGUID = '{34F20DB8-FA3C-4356-945D-5D7819E81C8B}';
  ProfilerClass: TComClass = TSampleProfiler;

implementation

uses
  ComServ;

procedure TSampleProfiler.OnInitialize;
begin
  EventMask := COR_PRF_MONITOR_CLASS_LOADS;
end;

procedure TSampleProfiler.OnShutDown;
begin
  //Nothing to do
end;

procedure TSampleProfiler.ClassLoadStarted(classId: ULONG);
begin
  SyncEnter;
  Beep(200 + Random(300), 20);
  SyncExit
end;

initialization
  TComObjectFactory.Create(ComServer, ProfilerClass, ProfilerGUID,
    ProfilerCoClassName, ProfilerDescription, ciMultiInstance, tmFree);
end.
